
NO_ERROR		equ	0
ERROR_NO_MORE_ITEMS	equ	259

;winuser.h
MB_ICONINFORMATION	equ	40h
IDI_APPLICATION		equ	32512
CS_HREDRAW		equ	2
CS_VREDRAW		equ	1
CW_USEDEFAULT		equ	80000000h
WS_OVERLAPPEDWINDOW	equ	0CF0000h
IDC_ARROW		equ	32512
SW_SHOWNORMAL		equ	1
COLOR_WINDOW		equ	5

;Messages
WM_DESTROY		equ	2
WM_INITDIALOG		equ	110h
WM_CLOSE		equ	10h
WM_COMMAND		equ	111h
WM_SETFONT                           equ 30h
WM_CTLCOLORLISTBOX                   equ 134h
WM_SETICON                           equ 80h

;;for WM_SETICON
ICON_SMALL                                 equ 0
ICON_BIG                                 equ 1

MB_OK			equ	0
BN_CLICKED		equ	0

;ListBoxes
LB_ADDSTRING                         equ 180h
LB_SETCOLUMNWIDTH                    equ 195h
GWL_STYLE                            equ -16
GWL_EXSTYLE                          equ -20

;getstockobject
OEM_FIXED_FONT                       equ 10
ANSI_FIXED_FONT                      equ 11
ANSI_VAR_FONT                        equ 12
SYSTEM_FONT                          equ 13
DEVICE_DEFAULT_FONT                  equ 14
DEFAULT_PALETTE                      equ 15
SYSTEM_FIXED_FONT                    equ 16

WS_EX_DLGMODALFRAME                  equ 1h
WS_EX_CLIENTEDGE                     equ 00000200h
WS_EX_STATICEDGE                     equ 00020000h
WS_CAPTION                           equ 0C00000h

SWP_NOSIZE                           equ 1h
SWP_NOMOVE                           equ 2h
SWP_NOZORDER                         equ 4h
SWP_NOREDRAW                         equ 8h
SWP_NOACTIVATE                       equ 10h
SWP_FRAMECHANGED                     equ 20h
SWP_SHOWWINDOW                       equ 40h
SWP_HIDEWINDOW                       equ 80h
SWP_NOCOPYBITS                       equ 100h
SWP_NOOWNERZORDER                    equ 200h
SWP_DRAWFRAME                        equ SWP_FRAMECHANGED
SWP_NOREPOSITION                     equ SWP_NOOWNERZORDER
SWP_DEFERERASE                                equ 2000h
SWP_ASYNCWINDOWPOS                            equ 4000h

;include apicalls.inc
	includelib	import32.lib

	extrn	CreateSolidBrush:near
	extrn	SetTextColor:near
	extrn	SetBkColor:near

	extrn	LoadIconA:near
	extrn	SetWindowPos:near

	extrn	SetWindowLongA:near
	extrn	GetWindowLongA:near

	extrn	ExitProcess:near
	extrn	GetModuleHandleA:near
	extrn	DialogBoxParamA:near
	extrn	DialogBoxParamW:near
	extrn	EndDialog:near
	extrn	SendMessageA:proc
	extrn	SendMessageW:proc
	extrn	GetDlgItem:proc
	extrn 	wsprintfW:proc
	extrn	GetStockObject:proc
	.386
	.model flat,stdcall

	.data
;fmt		db "%03d-%hC",0
;fmt		dw "%","0","3","d","-","%","h","C",0
fmt		dw "%","d","-","%","h","C",0

	.data?
dlg_hwnd	dd	?
hinst		dd ?
hk_hwnd		dd	?
buffer db 8 dup(?)
	.code
_start:
	xor	ebx,ebx
	push	ebx
	call	GetModuleHandleA
	mov		hinst,eax

	push	ebx
	push	offset	dialog_proc
	push	ebx
	push	1000
	push	eax
	call	DialogBoxParamA

;	cmp	eax,0ffffffffh
;	jz	failure

failure:
	push	ebx
	call	ExitProcess

dialog_proc	proc	near
	push	ebp
	mov	ebp,esp
dp_hWnd		equ	dword ptr [ebp+08h] ; DIALOG_id
dp_uMsg		equ	dword ptr [ebp+0Ch] ; message #
dp_wParam	equ	dword ptr [ebp+10h] ; 1st param.
dp_lParam	equ	dword ptr [ebp+14h] ; 2nd param.

	mov		ecx,dp_hWnd
	mov		eax,dp_uMsg
	cmp		eax,WM_INITDIALOG
	jne		not_initdialog
	push	eax
	call	initlb
	call	LoadIconA,hinst,800
	call	SendMessageA,dp_hWnd,WM_SETICON,ICON_SMALL,eax
	push	esi
	call	GetDlgItem,dp_hWnd,1001
	mov		esi,eax
	call	GetWindowLongA,eax,GWL_EXSTYLE
;	and		eax,0-WS_CAPTION
	and		eax,0-(WS_EX_DLGMODALFRAME + WS_EX_CLIENTEDGE + WS_EX_STATICEDGE)
	call	SetWindowLongA,esi,GWL_EXSTYLE,eax

	call	SetWindowPos,esi, ebx, ebx,ebx,ebx,ebx, SWP_FRAMECHANGED + SWP_NOMOVE + SWP_NOSIZE + SWP_NOZORDER + SWP_NOOWNERZORDER
	pop		esi
	pop		eax
not_initdialog:
	cmp	eax,WM_CLOSE
	je	close_dlg

	cmp	eax,WM_COMMAND
	jne not_cmd;not_command
	mov	eax,dp_wParam
	cmp	ax,2
	je	close_dlg
	jmp not_exit
not_cmd:
	cmp	eax,WM_CTLCOLORLISTBOX
	jne not_command
;hw=hwnd;
;hw=GetWindow(hw,GW_CHILD);
;hdc=GetWindowDC(hw);
;           SetTextColor(hdc,RGB(128,0,0));
;           SetBkColor(hdc,RGB(0,0,0));
;               break;
;hdcLB = (HDC) wParam;
	call SetTextColor,dp_wParam,0;00FFFFFFh
	call SetBkColor,dp_wParam,00707070h
	call CreateSolidBrush,00707070h;;0012FFFFh;mov	eax,000FF0080h
	jmp	a_exit;not_exit;not_command
;	jmp	not_command

close_dlg:
	call	EndDialog,ecx,0
command:

not_exit:
	xor	eax,eax
	inc	eax
a_exit:
	leave
	ret	16
not_command:
	xor	eax,eax
	leave
	ret	16

dialog_proc	endp

initlb proc
	push	ebx
	call	GetDlgItem,dp_hWnd,1001
	mov		ebx,eax
	push	esi
	mov		esi,32;xor esi,esi
	call 	SendMessageW,ebx,LB_SETCOLUMNWIDTH,40,0
;	call	GetStockObject,SYSTEM_FIXED_FONT;OEM_FIXED_FONT
;	call 	SendMessageW,ebx,WM_SETFONT,eax,0
add_column:
	call 	wsprintfW,offset buffer,offset fmt,esi,esi
	add		esp,10h
	call 	SendMessageW,ebx,LB_ADDSTRING,0,offset buffer
	inc		esi
	cmp		esi,256
	jne		add_column
	pop		esi
	pop		ebx

	ret
initlb endp
end	_start
